function [xmin, fmin, FES, succ] = CoNI(fn_name, a, b, Np, nepo, k, n_rnd, maxFES, shift)
% Np = 15; % island size
% nepo = 10;    %gens before migration
% k = 8;  % numb. of algorithms (islands)
% n_rnd = 4; % number of randomly chosen ind. from each sub-pop. !!! n_rnd + 1 < Np !!!

FES_lim = zeros(17, 1);
for i = 1:3
    FES_lim(i) = fix((0.1^(5 - i)) * maxFES);
end
for i = 2:5
    FES_lim(i + 2) = 0.01 * i * maxFES;
end
for i = 1:10
    FES_lim(i + 7) = 0.1 * i * maxFES;
end
fmin_stage = NaN(17, 1);
stage = 1;
diam = NaN(1, 17);
best_alg_stage = zeros(1, 17);
D = length(a);
P = zeros(Np, D + 1, k);                                                    % alocate k islands by Np individuals
poc_gen = 0;
poc_mig = 0;
for j = 1:k                                                                 % For each island..
    P(:, 1:D, j) = repmat(a, [Np 1]) + rand(Np, D) .* repmat((b - a), [Np 1]);
    for jj = 1:Np
        P(jj, D + 1, j) = feval(fn_name, P(jj, 1:D, j) - shift);
    end
end
FES = Np * k;% + Npm;                                                        % Npumber of function evaluating
succ = zeros(1, k);
%sucm = 0;
epoch = 1;                                                                  % Npumber of alg. runs before Fmin
% ABC params
abc_limit = Np;
abc_Fitness = calculateFitness(P(:, D + 1, 1));
%reset trial counters
abc_trial = zeros(1, Np);
abc_nscout = 0;

% Bat parameters
bat_r0 = 0.1;
bat_r = bat_r0 * ones(Np, 1);
bat_A = 1.2 * ones(Np, 1);
%eps = 0.001;
bat_Qmin = 0;        % Frequency minimum
bat_Qmax = 100; % Frequency maximum pro CEC11 nejsou stejne!!!
bat_Q = zeros(Np, 1);  % Frequency
bat_v = zeros(Np, D);  % Velocities
gen = 1;
%Cuckoo params
cs_pa = 0.25; %0.1 - 0.5
cs_beta = 3 / 2;
%DFO params:
dfo_dt = 0.001;
dfo_nb = zeros(Np, 1);
% Firefly params:
ff_alpha=0.5;      % Randomness 0--1 (highly random)
ff_gamma=1.0;      % Absorption coefficient
ff_betamin=0.2;      % Randomness reduction (similar to an annealing schedule)
fl_p = 0.8;
%PSO params
pso_c1=1.05; pso_c2=1.05;
pso_wmax = 1; pso_wmin = 0.3; %set to same value for constant w
pso_w = linspace(pso_wmax, pso_wmin, ceil((maxFES / k) / Np)); % uprava maxfes/k
pso_iter = 1;
pso_v = repmat(((b - a) ./ 4), Np, 1) .* rand(Np, D); % pocatecnich rychlosti
%SOMA params:
soma_mass = 2;
soma_step = 0.11;
soma_prt = 0.1;
soma_pocet_kroku = fix(soma_mass / soma_step);

% alocate special parameters of DEs END------------------------------------
while (FES < maxFES)
    for ii = 1:nepo                                                          % Run nepo-generations of DE before migration
        %------------------------------------------
        % ABC on 1. island
        for i = 1:Np
            %/*The parameter to be changed is determined randomly*/
            Param2Change = fix(rand * D) + 1;
            %/*A randomly chosen solution is used in producing a mutant solution of the solution i*/
            neighbour = fix(rand * Np) + 1;
            %/*Randomly selected solution must be different from the solution i*/
            while(neighbour == i)
                neighbour = fix(rand * Np) + 1;
            end;
            sol = P(i, 1:D, 1);
            %  /*v_{ij}=x_{ij}+\phi_{ij}*(x_{kj}-x_{ij}) */
            sol(Param2Change) = P(i, Param2Change, 1) + (P(i, Param2Change, 1) - P(neighbour, Param2Change, 1)) * (rand - 0.5) * 2;
            %  /*if generated parameter value is out of boundaries, it is shifted onto the boundaries*/
            % Mirroring
            outbound = find(sol < a | sol > b);
            for j = outbound
                while (sol(j) < a(j) || sol(j) > b(j))
                    if sol(j) > b(j)
                        sol(j) = 2 * b(j) - sol(j);
                    elseif sol(j) < a(j)
                        sol(j) = 2* a(j) - sol(j);
                    end
                end
            end
            %evaluate new solution
            % calculate goal function
            ObjValSol = feval(fn_name, sol - shift);
            FitnessSol = calculateFitness(ObjValSol);
            % /*a greedy selection is applied between the current solution i and its mutant*/
            if (FitnessSol > abc_Fitness(i)) %/*If the mutant solution is better than the current solution i, replace the solution with the mutant and reset the trial counter of solution i*/
                P(i, 1:D, 1) = sol;
                abc_Fitness(i) = FitnessSol;
                P(i, D + 1, 1) = ObjValSol;
                abc_trial(i) = 0;
                succ(1) = succ(1) + 1;
            else
                abc_trial(i) = abc_trial(i) + 1; %/*if the solution i can not be improved, increase its trial counter*/
            end
        end
        FES = FES + Np;
        %%%%%%%%%%%%%%%%%%%%%%%% CalculateProbabilities %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %/* A food source is chosen with the probability which is proportioal to its quality*/
        %/*Different schemes can be used to calculate the probability values*/
        %/*For example prob(i)=fitness(i)/sum(fitness)*/
        %/*or in a way used in the metot below prob(i)=a*fitness(i)/max(fitness)+b*/
        %/*probability values are calculated by using fitness values and normalized by dividing maximum fitness value*/
        prob = (0.9 .* abc_Fitness ./ max(abc_Fitness)) + 0.1;
        %%%%%%%%%%%%%%%%%%%%%%%% ONLOOKER BEE PHASE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        i = 1;
        t = 0;
        while(t < Np)
            if(rand < prob(i))
                t = t + 1;
                %/*The parameter to be changed is determined randomly*/
                Param2Change = fix(rand * D) + 1;
                %/*A randomly chosen solution is used in producing a mutant solution of the solution i*/
                neighbour = fix(rand * Np) + 1;
                %/*Randomly selected solution must be different from the solution i*/
                while(neighbour == i)
                    neighbour = fix(rand * Np) + 1;
                end
                sol = P(i, 1:D, 1);
                %  /*v_{ij}=x_{ij}+\phi_{ij}*(x_{kj}-x_{ij}) */
                sol(Param2Change) = P(i, Param2Change, 1) + (P(i, Param2Change, 1) - P(neighbour, Param2Change, 1)) * (rand - 0.5) * 2;
                %  /*if generated parameter value is out of boundaries, it is shifted onto the boundaries*/
                % Mirroring
                outbound = find(sol < a | sol > b);
                for j = outbound
                    while (sol(j) < a(j) || sol(j) > b(j))
                        if sol(j) > b(j)
                            sol(j) = 2 * b(j) - sol(j);
                        elseif sol(j) < a(j)
                            sol(j) = 2 * a(j) - sol(j);
                        end
                    end
                end
                %evaluate new solution
                ObjValSol = feval(fn_name, sol - shift);
                FES = FES + 1;
                FitnessSol = calculateFitness(ObjValSol);
                % /*a greedy selection is applied between the current solution i and its mutant*/
                if (FitnessSol > abc_Fitness(i)) %/*If the mutant solution is better than the current solution i, replace the solution with the mutant and reset the trial counter of solution i*/
                    P(i, 1:D, 1) = sol;
                    abc_Fitness(i) = FitnessSol;
                    P(i, D + 1, 1) = ObjValSol;
                    abc_trial(i) = 0;
                    succ(1) = succ(1) + 1;
                else
                    abc_trial(i) = abc_trial(i) + 1; %/*if the solution i can not be improved, increase its trial counter*/
                end
            end
            i = i + 1;
            if (i == Np + 1)
                i = 1;
            end
        end
        %
        %/*The best food source is memorized*/
        [fmin, ~] = min(P(:, D + 1, 1));
        best_alg_stage(stage) = 1;
        for j = 2:k
            if min(P(:, D + 1, j)) < fmin
                [fmin, ~] = min(P(:, D + 1, j));
                best_alg_stage(stage) = j;
            end
        end
        if  stage < 17 && isnan(fmin_stage(stage)) && FES >= FES_lim(stage)
            fmin_stage(stage) = fmin;
            dipom = zeros(1, k);
            for j = 1:k
                dipom(j) = sqrt(sum(sum((P(:, 1:D, j) - repmat(mean(P(:, 1:D, j)), Np, 1)) .* (P(:, 1:D, j) - repmat(mean(P(:, 1:D, j)), Np, 1)))) / Np);
            end
            diam(stage) = sum(dipom) / k;
            stage = stage + 1;
        end
        %%%%%%%%%%%% SCOUT BEE PHASE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %/*determine the food sources whose trial counter exceeds the "limit" value.
        %In Basic ABC, only one scout is allowed to occur in each cycle*/
        ind = find(abc_trial == max(abc_trial));
        ind = ind(end);
        if (abc_trial(ind) > abc_limit)
            abc_trial(ind) = 0;
            sol = (b - a) .* rand(1, D) + a;
            %evaluate new solution
            ObjValSol = feval(fn_name, sol - shift);
            FES = FES + 1;
            FitnessSol = calculateFitness(ObjValSol);
            P(ind, 1:D, 1) = sol;
            abc_Fitness(ind) = FitnessSol;
            P(ind, D + 1, 1) = ObjValSol;
            abc_nscout = abc_nscout + 1;
        end
        if FES >= maxFES
            break
        end
    end
    
    [~, indmin] = min(P(:, D + 1, 2));
    xbest = P(indmin, 1:D, 2);
    for ii = 1:nepo                                                          % Run nepo-generations of DE before migration
        %------------------------------------------
        % Bat on 2. island
        for i = 1:Np  %  new generation
            bat_Q(i) = bat_Qmin + (bat_Qmax - bat_Qmin) * rand(1);
            bat_v(i, :) = bat_v(i, :) + (P(i, 1:D, 2) - xbest) * bat_Q(i);
            new = P(i, 1:D, 2) + bat_v(i, :);
            % Pulse rate
            if rand > bat_r(i)
                % The factor 0.001 limits the cs_step sizes of random walks
                new = xbest + mean(bat_A) * (2 * rand(1) - 1); % oprava bylo bezA(i)
                %disp(ri(i));
            end
            % Mirroring
            outbound = find(new < a | new > b);
            for j=outbound
                while (new(j) < a(j) || new(j) > b(j))
                    if new(j) > b(j)
                        new(j) = 2 * b(j) - new(j);
                    elseif new(j) < a(j)
                        new(j) = 2 * a(j) - new(j);
                    end
                end
            end
            % fitness EVALUATION
            fnew = feval(fn_name, new - shift);
            % Update if the solution improves, or not too loud
            if (fnew <= P(i, D + 1, 2)) && (randn < bat_A(i))
                P(i, 1:D, 2) = new;
                P(i, D + 1, 2) = fnew;
                %%redukce
                bat_A(i) = 0.9 * bat_A(i);
                %zvyen
                bat_r(i) = bat_r0 * (1 - exp(-0.9 * gen));
                succ(2) = succ(2) + 1;
            end
            % Update the current xbest solution
            if fnew <= fmin
                xbest = new;
                fmin = fnew;
            end
            gen = gen + 1;
        end % end of generation
        FES = FES + Np;
        best_alg_stage(stage) = 1;
        for j = 2:k
            if min(P(:, D + 1, j)) < fmin
                fmin = min(P(:, D + 1, j));
                best_alg_stage(stage) = j;
            end
        end
        if  stage < 17 && isnan(fmin_stage(stage)) && FES >= FES_lim(stage)
            fmin_stage(stage) = fmin;
            dipom = zeros(1, k);
            for j = 1:k
                dipom(j) = sqrt(sum(sum((P(:, 1:D, j) - repmat(mean(P(:, 1:D, j)), Np, 1)) .* (P(:, 1:D, j) - repmat(mean(P(:, 1:D, j)), Np, 1)))) / Np);
            end
            diam(stage) = sum(dipom) / k;
            stage = stage + 1;
        end
        if FES >= maxFES
            break
        end
    end
    
    
    
    
    for ii = 1:nepo
        %------------------------------------------
        % Cuckoo on 3. island
        %get_cuckoos
        [~, indmin] = min(P(:, D + 1, 3));
        cs_best = P(indmin, 1:D, 3);
        cs_sigma = (gamma(1 + cs_beta) * sin(pi * cs_beta / 2) / (gamma((1 + cs_beta) / 2) * cs_beta * 2^((cs_beta - 1) / 2)))^(1 / cs_beta);
        for i = 1:Np
            s = P(i, 1:D, 3);
            % This is a simple way of implementing Levy flights
            % For standard random walks, use cs_step=1;
            %% Levy flights by Mantegna's algorithm
            cs_u = randn(size(s)) * cs_sigma;
            cs_v = randn(size(s));
            cs_step = cs_u ./ abs(cs_v) .^ (1 / cs_beta);
            % In the next equation, the difference factor (s-best) means that
            % when the solution is the best solution, it remains unchanged.
            cs_stepsize = 0.01 * cs_step .* (s - cs_best);
            % Here the factor 0.01 comes from the fact that L/100 should the typical
            % cs_step size of walks/flights where L is the typical lenghtscale;
            % otherwise, Levy flights may become too aggresive/efficient,
            % which makes new solutions (even) jump out side of the design domain
            % (and thus wasting evaluations).
            % Now the actual random walks or flights
            s = s + cs_stepsize .* randn(size(s));
            % Apply simple bounds/limits
            %nest(i, :) = simplebounds(s, Lb, Ub);
            % Mirroring
            outbound = find(s < a | s > b);
            for j = outbound
                while (s(j) < a(j) || s(j) > b(j))
                    if s(j) > b(j)
                        s(j) = 2 * b(j) - s(j);
                    elseif s(j) < a(j)
                        s(j) = 2 * a(j) - s(j);
                    end
                end
            end
            % fitness EVALUATION
            fnew = feval(fn_name, s - shift);
            % selection
            if fnew <= P(i, D + 1, 3)
                P(i, D + 1, 3) = fnew;
                P(i, 1:D, 3) = s;
                succ(3) = succ(3) + 1;
            end
        end
        FES = FES + Np;
        cs_K = rand(size(P(:, 1:D, 3))) > cs_pa;
        % In the real world, if a cuckoo's egg is very similar to a host's eggs, then
        % this cuckoo's egg is less likely to be discovered, thus the fitness should
        % be related to the difference in solutions.  Therefore, it is a good idea
        % to do a random walk in a biased way with some random cs_step sizes.
        %% New solution by biased/selective random walks
        cs_stepsize = rand(1) * (P(randperm(Np), 1:D, 3) - P(randperm(Np), 1:D, 3));
        new_nest = P(:, 1:D, 3)  + cs_stepsize .* cs_K;
        for i = 1:size(new_nest, 1)
            mirs = new_nest(i, :);
            % Mirroring
            outbound = find(mirs < a | mirs > b);
            for j = outbound
                while (mirs(j) < a(j) || mirs(j) > b(j))
                    if mirs(j) > b(j)
                        mirs(j) = 2 * b(j) - mirs(j);
                    elseif mirs(j) < a(j)
                        mirs(j) = 2 * a(j) - mirs(j);
                    end
                end
            end
            new_nest(i, :) = mirs;
            % fitness EVALUATION
            fnew = feval(fn_name, new_nest(i, :) - shift);
            % selection
            if fnew <= P(i, D + 1, 3)
                P(i, D + 1, 3) = fnew;
                P(i, 1:D, 3) = new_nest(i, :);
                succ(3) = succ(3) + 1;
            end
        end
        FES = FES + Np;
        [~, indmin] = min(P(:, D + 1, 3));
        cs_best = P(indmin, 1:D, 3);
        
        fmin = min(P(:, D + 1, 1));
        best_alg_stage(stage) = 1;
        for j = 2:k
            if min(P(:, D + 1, j)) < fmin
                fmin = min(P(:, D + 1, j));
                best_alg_stage(stage) = j;
            end
        end
        if  stage < 17 && isnan(fmin_stage(stage)) && FES >= FES_lim(stage)
            fmin_stage(stage) = fmin;
            dipom = zeros(1, k);
            for j = 1:k
                dipom(j) = sqrt(sum(sum((P(:, 1:D, j) - repmat(mean(P(:, 1:D, j)), Np, 1)) .* (P(:, 1:D, j) - repmat(mean(P(:, 1:D, j)), Np, 1)))) / Np);
            end
            diam(stage) = sum(dipom) / k;
            stage = stage + 1;
        end
        if FES >= maxFES
            break
        end
    end
    
    
    
    for ii = 1:nepo
        %------------------------------------------
        % DFO on 4. island
        [dfo_fmin, indmin] = min(P(:, D + 1, 4));
        dfo_best = P(indmin, 1:D, 4);
        Q = P(:, 1:D, 4);
        
        %1. moucha
        if P(Np, D + 1, 4) < P(2, D + 1, 4)
            dfo_nb(1) = Np;
        elseif P(Np, D + 1, 4) > P(2, D + 1, 4)
            dfo_nb(1) = 2;
        else
            if rand < 0.5
                dfo_nb(1) = Np;
            else
                dfo_nb(1) = 2;
            end
        end
        %2. - N-1. moucha
        for i = 2:Np - 1  %  in each generation
            if P(i - 1, D + 1, 4) < P(i + 1, D + 1, 4)
                dfo_nb(i) = i - 1;
            elseif P(i - 1, D + 1, 4) > P(i + 1, D + 1, 4)
                dfo_nb(i) = i + 1;
            else
                if rand < 0.5
                    dfo_nb(i) = i - 1;
                else
                    dfo_nb(i) = i + 1;
                end
            end
        end
        %N. moucha
        if P(Np - 1, D + 1, 4) < P(1, D + 1, 4)
            dfo_nb(Np) = Np - 1;
        elseif P(Np - 1, D + 1, 4) > P(1, D + 1, 4)
            dfo_nb(Np) = 1;
        else
            if rand < 0.5
                dfo_nb(Np) = Np - 1;
            else
                dfo_nb(Np) = 1;
            end
        end
        for i = 1:Np  %  new generation
            Q(i, :) = P(dfo_nb(i), 1:D, 4) + rand(1, D) .* (dfo_best - P(i, 1:D, 4));
        end % end of generation
        %%%  dispersion
        QQ = Q;
        Rmat = rand(Np * D, 1);
        mutuj = find(Rmat < dfo_dt);
        for i = mutuj
            % QQ(i) = a(1)+(b(1)-a(1)).*rand(1,1); % Rmat(i,1);
            QQ(i) = a(1) + (b(1) - a(1)) * Rmat(i);
        end
        % size(QQ)
        Q = reshape(QQ, Np, D);
        % Mirroring
        for i = 1:Np
            s = QQ(i, :);
            outbound = find(s < a | s > b);
            for j = outbound
                while (s(j) < a(j) || s(j) > b(j))
                    if s(j) > b(j)
                        s(j) = 2 * b(j) - s(j);
                    elseif s(j) < a(j)
                        s(j) = 2 * a(j) - s(j);
                    end
                end
            end
            Q(i, :) = s;
        end
        for i = 1:Np
            % fitness EVALUATION
            fy = feval(fn_name, Q(i, :) - shift);
            if fy < P(i, D + 1, 4)
                succ(4) = succ(4) + 1;
            end
            P(i, :, 4) = [Q(i, :) fy];
        end
        FES = FES + Np;
        if min(P(:, D + 1, 4)) < dfo_fmin
            [dfo_fmin, indmin] = min(P(:, D + 1, 4));
            dfo_best = P(indmin, 1:D, 4);
        end
        fmin = min(P(:, D + 1, 1));
        best_alg_stage(stage) = 1;
        for j = 2:k
            if min(P(:, D + 1, j)) < fmin
                fmin = min(P(:, D + 1, j));
                best_alg_stage(stage) = j;
            end
        end
        if  stage < 17 && isnan(fmin_stage(stage)) && FES >= FES_lim(stage)
            fmin_stage(stage) = fmin;
            dipom = zeros(1, k);
            for j = 1:k
                dipom(j) = sqrt(sum(sum((P(:, 1:D, j) - repmat(mean(P(:, 1:D, j)), Np, 1)) .* (P(:, 1:D, j) - repmat(mean(P(:, 1:D, j)), Np, 1)))) / Np);
            end
            diam(stage) = sum(dipom) / k;
            stage = stage + 1;
        end
        if FES >= maxFES
            break
        end
    end
    
    for ii = 1:nepo
        %------------------------------------------
        % Firefly on 5. island
        % update alpha
        ff_delta = 1 - (10^(-4) / 0.9)^(1 / round((maxFES / k) / Np)); % uprava, kde jsme maxfes vydelili pro 1 "ostrov"
        ff_alpha = (1 - ff_delta) * ff_alpha;
        % Move all fireflies to the better locations:
        % Scaling of the system
        ff_scale = abs(b - a);
        % Updating fireflies
        for i = 1:Np
            % The attractiveness parameter beta=exp(-gamma*soma_r)
            for j = 1:Np % v clanku je j=1:i
                ff_r = sqrt(sum((P(i, 1:D, 5) - P(j, 1:D, 5)) .^ 2));
                % Update moves
                if P(i, D + 1, 5) > P(j, D + 1, 5) % Brighter and more attractive - bylo ">"
                    ff_beta0 = 1;
                    ff_beta = (ff_beta0 - ff_betamin) * exp(-ff_gamma * ff_r .^ 2) + ff_betamin;
                    ff_tmpf = ff_alpha .* (rand(1, D) - 0.5) .* ff_scale;
                    new = P(i, 1:D, 5) .* (1 - ff_beta) + P(j, 1:D, 5) .* ff_beta + ff_tmpf;
                    % Mirroring
                    outbound = find(new < a | new > b);
                    for jj = outbound
                        while (new(jj) < a(jj) || new(jj) > b(jj))
                            if new(jj) > b(jj)
                                new(jj) = 2 * b(jj) - new(jj);
                            elseif new(jj) < a(jj)
                                new(jj) = 2 * a(jj) - new(jj);
                            end
                        end
                    end
                    % fitness EVALUATION
                    fnew = feval(fn_name, new - shift);
                    % save better fly
                    if fnew < P(i, D + 1, 5)
                        P(i, :, 5) = [new, fnew];
                        succ(5) = succ(5) + 1;
                    end
                end
            end % end for j
        end % end for generation
        FES = FES + Np;
        %fmin = min(min(min(P(:, D + 1, :))), min(P1(:, D + 1)));
        fmin = min(P(:, D + 1, 1));
        best_alg_stage(stage) = 1;
        for j = 2:k
            if min(P(:, D + 1, j)) < fmin
                fmin = min(P(:, D + 1, j));
                best_alg_stage(stage) = j;
            end
        end
        if  stage < 17 && isnan(fmin_stage(stage)) && FES >= FES_lim(stage)
            fmin_stage(stage) = fmin;
            dipom = zeros(1, k);
            for j = 1:k
                dipom(j) = sqrt(sum(sum((P(:, 1:D, j) - repmat(mean(P(:, 1:D, j)), Np, 1)) .* (P(:, 1:D, j) - repmat(mean(P(:, 1:D, j)), Np, 1)))) / Np);
            end
            diam(stage) = sum(dipom) / k;
            stage = stage + 1;
        end
        if FES >= maxFES
            break
        end
    end
    
    [~, indmin] = min(P(:, D + 1, 6));
    xbest = P(indmin, 1:D, 6);
    for ii = 1:nepo
        %------------------------------------------
        % Flower on 6. island
        % Loop over all bats/solutions
        for i = 1:Np
            % Pollens are carried by insects and thus can move in
            % large scale, large distance.
            % This L should replace by Levy flights
            % Formula: x_i^{t+1}=x_i^t+ L (x_i^t-gbest)
            if rand > fl_p
                %% L=rand:
                % Levy exponent and coefficient
                % For details, see Chapter 11 of the following book:
                % Xin-She Yang, Nature-Inspired Optimization Algorithms, Elsevier, (2014).
                fl_beta = 3 / 2;
                fl_sigma = (gamma(1 + fl_beta) * sin(pi * fl_beta / 2) / (gamma((1 + fl_beta) / 2) * fl_beta * 2^((fl_beta - 1) / 2)))^(1 / fl_beta);
                fl_u = randn(1, D) * fl_sigma;
                fl_v = randn(1, D);
                fl_step = fl_u ./ abs(fl_v) .^ (1 / fl_beta);
                fl_L = 0.01 * fl_step;
                fl_dS = fl_L .* (P(i, 1:D, 6) - xbest);
                new = P(i, 1:D, 6) + fl_dS;
                % Mirroring
                outbound = find(new < a | new > b);
                for j=outbound
                    while (new(j) < a(j) || new(j) > b(j))
                        if new(j) > b(j)
                            new(j) = 2 * b(j) - new(j);
                        elseif new(j) < a(j)
                            new(j) = 2 * a(j) - new(j);
                        end
                    end
                end
                % If not, then local pollenation of neighbor flowers
            else
                %epsilon = rand;
                % Find random flowers in the neighbourhood
                JK = nahvyb_expt(Np, 2, i);
                % As they are random, the first two entries also random
                % If the flower are the same or similar species, then
                % they can be pollenated, otherwise, no action.
                % Formula: x_i^{t+1}+epsilon*(x_j^t-x_k^t)
                new = P(i, 1:D, 6) + rand * (P(JK(1), 1:D, 6) - P(JK(2), 1:D, 6));
                % Check if the simple limits/bounds are OK
                % Mirroring
                outbound = find(new < a | new > b);
                for j=outbound
                    while (new(j) < a(j) || new(j) > b(j))
                        if new(j) > b(j)
                            new(j) = 2 * b(j) - new(j);
                        elseif new(j) < a(j)
                            new(j) = 2 * a(j) - new(j);
                        end
                    end
                end
            end
            
            % fitness EVALUATION
            fnew = feval(fn_name, new - shift);
            % If fitness improves (better solutions found), update then
            if (fnew <= P(i, D + 1, 6)),
                P(i, :, 6) = [new, fnew];
                succ(6) = succ(6) + 1;
            end
        end
        FES = FES + Np;
        
        fmin = min(P(:, D + 1, 1));
        best_alg_stage(stage) = 1;
        for j = 2:k
            if min(P(:, D + 1, j)) < fmin
                fmin = min(P(:, D + 1, j));
                best_alg_stage(stage) = j;
            end
        end
        
        if  stage < 17 && isnan(fmin_stage(stage)) && FES >= FES_lim(stage)
            fmin_stage(stage) = fmin;
            dipom = zeros(1, k);
            for j = 1:k
                dipom(j) = sqrt(sum(sum((P(:, 1:D, j) - repmat(mean(P(:, 1:D, j)), Np, 1)) .* (P(:, 1:D, j) - repmat(mean(P(:, 1:D, j)), Np, 1)))) / Np);
            end
            diam(stage) = sum(dipom) / k;
            stage = stage + 1;
        end
        if FES >= maxFES
            break
        end
    end
    
    [pso_gmin, indmin] = min(P(:, D + 1, 7));
    pso_gbest = P(indmin, 1:D, 7);
    pso_pbest = P(:, :, 7);
    for ii = 1:nepo
        %------------------------------------------
        % PSO on 7. island
        pso_v(1:Np, 1:D) = pso_w(pso_iter) * pso_v(1:Np, 1:D) + pso_c1 * rand(1) * (pso_pbest(1:Np, 1:D) - P(1:Np, 1:D, 7)) + pso_c2 * rand(1) * ((repmat(pso_gbest, Np, 1)) - P(1:Np, 1:D, 7));
        P(1:Np, 1:D, 7) = P(1:Np, 1:D, 7) + pso_v(1:Np, 1:D); % nova pozice
        for i = 1:Np
            P(i, 1:D, 7) = zrcad(P(i, 1:D, 7), a, b); % zabranuje opustit definicni obor
            % Mirroring
            outbound = find(P(i, 1:D, 7) < a | new > b);
            for j=outbound
                while (P(i, j, 7) < a(j) || P(i, j, 7) > b(j))
                    if P(i, j, 7) > b(j)
                        P(i, j, 7) = 2 * b(j) - P(i, j, 7);
                    elseif P(i, j, 7) < a(j)
                        P(i, j, 7) = 2 * a(j) - P(i, j, 7);
                    end
                end
            end
            % calculate goal function
            ObjValSol = feval(fn_name, P(i, 1:D, 7) - shift);
            %
            if ObjValSol < P(i, D + 1, 7)
                succ(7) = succ(7) + 1;
            end
            P(i, D + 1, 7) = ObjValSol; % zapis novou pozici a funkcni hodnotu
        end
        FES = FES + Np;
        pso_zmen = find(P(:, D + 1, 7) <= pso_pbest(:, D + 1));
        pso_pbest(pso_zmen, 1:D + 1) = P(pso_zmen, 1:D + 1, 7);
        [pso_fmin, indmin] = min(P(:, D + 1, 7));
        if pso_fmin < pso_gmin
            pso_gmin = pso_fmin;
            pso_gbest = P(indmin, 1:D, 7);
        end
        pso_iter = pso_iter + 1;
        
        fmin = min(P(:, D + 1, 1));
        best_alg_stage(stage) = 1;
        for j = 2:k
            if min(P(:, D + 1, j)) < fmin
                fmin = min(P(:, D + 1, j));
                best_alg_stage(stage) = j;
            end
        end
        if  stage < 17 && isnan(fmin_stage(stage)) && FES >= FES_lim(stage)
            fmin_stage(stage) = fmin;
            dipom = zeros(1, k);
            for j = 1:k
                dipom(j) = sqrt(sum(sum((P(:, 1:D, j) - repmat(mean(P(:, 1:D, j)), Np, 1)) .* (P(:, 1:D, j) - repmat(mean(P(:, 1:D, j)), Np, 1)))) / Np);
            end
            diam(stage) = sum(dipom) / k;
            stage = stage + 1;
        end
        if FES >= maxFES
            break
        end
    end
    
    P(:, :, 8) = sortrows(P(:, :, 8), D + 1);
    soma_xbest = P(1, 1:D, 8);
    for ii = 1:nepo
        %------------------------------------------
        % SOMA on 8. island
        soma_leader = P(1, 1:D, 8);
        for i = 2:Np
            soma_r0 = P(i, 1:D, 8); % starting position of individual
            soma_delta = (soma_leader - soma_r0) * soma_step; % delta is vector (1,d)
            %go ahead strategy
            %*****************
            soma_tochange = find(rand(1, D) < soma_prt);
            if isempty(soma_tochange)
                soma_tochange = 1 + fix(D * rand(1)); % at least one is changed
            end
            soma_C = zeros(soma_pocet_kroku, D + 1);
            soma_r = soma_r0;
            for j = 1:soma_pocet_kroku
                soma_r(soma_tochange) = soma_r(soma_tochange) + soma_delta(soma_tochange);
                % Mirroring
                outbound = find(soma_r < a | soma_r > b);
                for jj = outbound
                    while (soma_r(jj) < a(jj) || soma_r(jj) > b(jj))
                        if soma_r(jj) > b(jj)
                            soma_r(jj) = 2 * b(jj) - soma_r(jj);% - mod(soma_r(jj), (b(jj) - a(jj)));
                        elseif soma_r(jj) < a(jj)
                            soma_r(jj) = 2 * a(jj) - soma_r(jj);% - mod(soma_r(jj), (a(jj) - b(jj)));
                        end
                    end
                end
                % fitness EVALUATION
                soma_fr = feval(fn_name, soma_r - shift);
                soma_C(j, :) = [soma_r, soma_fr];
            end
            [~, indmin] = min(soma_C(:, D + 1));
            soma_yfy = soma_C(indmin, :); % row with min. fy is returned
            % end og go agead strategy
            % ************************
            FES = FES + soma_pocet_kroku;
            if soma_yfy(D + 1) < P(i , D + 1, 8) % trial point y is good
                P(i, :, 8) = soma_yfy;
                succ(8) = succ(8) + 1;
            end
        end
        P(:, :, 8) = sortrows(P(:, :, 8), D + 1); % fmin is in the 1st row
        
        fmin = min(P(:, D + 1, 1));
        best_alg_stage(stage) = 1;
        for j = 2:k
            if min(P(:, D + 1, j)) < fmin
                fmin = min(P(:, D + 1, j));
                best_alg_stage(stage) = j;
            end
        end
        if  stage < 17 && isnan(fmin_stage(stage)) && FES >= FES_lim(stage)
            fmin_stage(stage) = fmin;
            dipom = zeros(1, k);
            for j = 1:k
                dipom(j) = sqrt(sum(sum((P(:, 1:D, j) - repmat(mean(P(:, 1:D, j)), Np, 1)) .* (P(:, 1:D, j) - repmat(mean(P(:, 1:D, j)), Np, 1)))) / Np);
            end
            diam(stage) = sum(dipom) / k;
            stage = stage + 1;
        end
        if FES >= maxFES
            break
        end
    end
    
    poc_gen = poc_gen + (nepo * k);
    mi = randperm(k);
    for i = 1:k
        P(:, :, i) = sortrows(P(:, :, i), D + 1);
    end
    for i = 2:k
        ran1 = 1 + nahvyb(Np - 2, n_rnd);
        ran2 = 1 + nahvyb(Np - 2, n_rnd);
        if i == k %last
            % best --> worst
            P(Np, :, mi(1)) = P(1, :, mi(i));
            P(Np, :, mi(i)) = P(1, :, mi(i - 1));
            % several random between last and 1st
            pom = P(ran1, :, mi(i));
            P(ran1, :, mi(i)) = P(ran2, :, mi(1)); % several random are changed
            P(ran2, :, mi(1)) = pom;
        else
            % best --> worst
            P(Np, :, mi(i + 1)) = P(1, :, mi(i));
            P(Np, :, mi(i)) = P(1, :, mi(i - 1));
            % several random
            pom = P(ran1, :, mi(i));
            P(ran1, :, mi(i)) = P(ran2, :, mi(i - 1)); % several random are changed
            P(ran2, :, mi(i - 1)) = pom;
        end
    end
    poc_mig = poc_mig + k * (n_rnd + 1);
    
    % End of the epoch-----------------------------------------------------
    epoch = epoch + 1;
end                                                                         % Mainloop-end
[fmin, indmin] = min(P(:, D + 1, 1));
xmin = P(indmin, 1:D, 1);
for i = 2:k
    if min(P(:, D + 1, i)) < fmin
        [fmin, indmin] = min(P(:, D + 1, i));
        xmin = P(indmin, 1:D, i);
    end
end
